Datum1 = string (date())
Datum  = substr (Datum1, 5, 7) + substr (Datum1, 8, 10) + 
         substr (Datum1, 20, 24) + ", " + substr (Datum1, 12, 16)

OutputFil = "~/Error_Report.txt"
OutputFile = OutputFil
Continue = true
Counter = 1
while Continue do
  if (existf (OutputFile)) then
    OutputFile = OutputFil + "_" + string (Counter)
    Counter = Counter + 1
  else
    Continue = false
  end
end

`  -> Sorry, an error occured` nl
`Trying to write error report in file : ` [OutputFile] nl
`  Please fill this file with a complete description of the error and send it` nl
`  via fax, email or voice-mail to EUKLID Software GmbH                      ` nl
TabFiles = {}

file (OutputFile) output
`|===================================================================================` nl
`|  An/To                        |  Von/From                  |  Eingangsvermerk     ` nl
`|  EUKLID Software GmbH         |                            |                      ` nl
`|  Gruber Strasse 46 B          |                            |                      ` nl
`|                               |                            |                      ` nl
`|                               |                            |                      ` nl
`|  D-85586 Poing                |                            |                      ` nl
`|-----------------------------------------------------------------------------------` nl
`|  Tel: +49 8121 9924 10 (Support Center)    |  Your Tel:    ` nl
`|  Fax: +49 8121 9924 99                     |  Your Fax:    ` nl
`|  E-Mail:                                   |  Your E-Mail: ` nl
`|  EUKLIDDesign.Support@euklid-software.de   | ` nl
`|===================================================================================` nl
`| Datum/Date: ` [Datum] `                              Nr: ` nl
`|                                                             Gewicht/  ` nl
`| Bearbeiter/Your Name :                                      Priority: ` nl
`|                Login : ` [who()] nl
`|-----------------------------------------------------------------------------------` nl
`| Kurzbeschreibung: ` nl
`| Short Comment   : ` nl
`|-----------------------------------------------------------------------------------` nl
`| Productname:      ` [program.product_name] nl
`| Program:           ` [program.name] nl
`|-----------------------------------------------------------------------------------` nl
`| Operating System:  ` [program.sysname] ` ` [program.release] nl
`| Computername:      ` [program.nodename] nl
`| Processor:         ` [program.machine] nl
`|-----------------------------------------------------------------------------------` nl
`| Actual mode:       ` [program.mode] nl
`|-----------------------------------------------------------------------------------` nl
`| Last 5 actions: ` nl
for Act in program.l5n do
  `|` sp(10) [Act.name] nl
end
`|-----------------------------------------------------------------------------------` nl
`| (for easy copying required models on tape see file ~/Error_models) ` nl
`| Required UDx: ` nl
for Mod in models do
   `|  Model:    ` [Mod.name;-25] ` ` [Mod.number] nl
   `|  Filename: `
   if (valid (Mod.filename)) then
      [Mod.filename] nl
   else
      `*** not yet saved ***` nl
   end
   table_list = top.list_tab where .valid and valid (.created_by)
   if ( len (table_list) > 0 ) then
      `|   with table id number : `
      z = 0
      for Tab in table_list do
         z = z + 1
         if ( z = 1 ) then
            [Tab.number] nl
            `|              from file : ` [Tab.tabname]  nl
         else
            `|        table id number : ` [Tab.number] nl
            `|              from file : ` [Tab.tabname]  nl
         end
         if valid(Tab.tabname) then
            if not(Tab.tabname in TabFiles) then
               TabFiles = TabFiles + Tab.tabname
            end
         end
         for SubTab in Tab.ex_tab do
            if not(SubTab.tabname in TabFiles) then
               TabFiles = TabFiles + SubTab.tabname
            end
         end
      end
   end
   if ( len (Mod.required_udx_nodes) > 1 ) then
      `|    Required UDX          BEA-Id-Number/filename` nl
      for Udx in Mod.required_udx_nodes do
         `|    ` [Udx.name;-20] `: ` [Udx.expanded_number] nl
         `|       ` 
         if ( Udx.internal ) then
            `internal `
         else
            `external `
         end
         [Udx.type;-8] `: `
         if (valid (Udx.file)) then
            [Udx.file]
         end
         nl
         if (valid ( Udx.master )) then
            table_list = Udx.master.list_tab where .valid and valid (.created_by)
            if ( len (table_list) > 0 ) then
               `|       with table id nr : `
               z = 0
               for Tab in table_list do
                  z = z + 1
                  if ( z = 1 ) then
                     [Tab.number] nl
                     `|              from file : ` [Tab.tabname]  nl
                  else
                     `|            table id nr : ` [Tab.number] nl
                     `|              from file : ` [Tab.tabname]  nl
                  end
                  if valid(Tab.tabname) then
                     if not(Tab.tabname in TabFiles) then
                        TabFiles = TabFiles + Tab.tabname
                     end
                  end
                  for SubTab in Tab.ex_tab do
                     if not(SubTab.tabname in TabFiles) then
                        TabFiles = TabFiles + SubTab.tabname
                     end
                  end
               end
            end
         end
      end
   end
end
`|-----------------------------------------------------------------------------------` nl
`| Fehlerbeschreibung/Error Description:` nl
`| ` nl
`| ` nl
`| ` nl
file <screen>

OutputFileModels = "~/Error_models.txt"
`    -> Please see file `[OutputFileModels]`, too` nl
file (OutputFileModels) output
for Mod in models do
   if (valid (Mod.filename)) then
      [Mod.filename] nl
   end
   for Udx in Mod.required_udx_nodes do
      if (valid (Udx.file)) then
         [Udx.file] nl
      end
   end
end
for tab in TabFiles do
   if valid(tab) then
      [tab]
   else
      `*** NONAME ***`
   end
   nl
end
file <screen>

`Finished writing error report in file: ` [OutputFile] nl nl
