// Common functions for the Draft to ObjectD converter
//

// Initialisation 
var ul = "is_limited"
var ila = {"solid",0.25}
var z = length_absolute(0)
var ax = "no_axes"
var z_inc = 0.001
var meas_ang = angle_measparallel()
var keep_replace = false
// linestyles
var ls_solid =   "solid"
var ls_dashed =  "dashed"
var ls_dotted =  "dotted"
var ls_dashdotted  = "dashdotted"
var ls_dashdotdotted = "dashdotdotted"
var errorProtocol = protocolDir + "/" + sourceFile + ".log"

// Software line styles
var soft_styles =
        {
          { "none_arrow"},
          { "arrow_none"},
          { "none_slash"},
          { "slash_none"},
          { "none_circle"},
          { "circle_none"},
          { "none_triangle"},
	  { "none"},
          { "circle_arrow"},
          { "arrow_circle"},
          { "circle_slash"},
          { "slash_circle"},
          { "arrow_arrow"},
          { "slash_slash"},
          { "circle_circle"},
	  { "none"}
       }

function udo_exists(udo_name)
        var udo_node
	udo_node = eval ("application.o_"+udo_name)
	if valid (udo_node) then
	   `UDO ` [udo_name] ` not created. Does already exist` nl
	   return(true)
	end
	return(false)
end

function start_new_udo(udo_name)
	udo_mast = udo_master(udo_name)
	par_point = point_relative(origin,0,0)
	par_angle=angle_abs(0)
	par_scale=1
	coor = coord_onpoint(par_point)
	par_world = world_firstrota(coor,par_angle,par_scale)
	p_org = point_origin(par_world)
	delete(par_world)
	return(p_org)
end

function end_new_udo(udo_name,param_z,p_org)
	p_world = p_org.created_by.par_o.created_by
	p_coor = p_world.par_pos.created_by
	param_z=param_z.created_by
	result_udo =  udo_define (
		{
		  program.give_node_number,
		  program.give_node_number,
		  { "selectable", "state_change", "drawable", "special_values", "user" }
	,
		  { "no_icon" },
		  { {   program.give_node_number,
			"prop_or_par_act_par",
			param_z,
			application.a_length_sum.p_l1,
			{ "draft" },
			"z",
			{ "std_icon", application.o_line.p_z }
		    },
		    {   program.give_node_number,
			"prop_or_par_act_par",
			p_coor,
			application.a_coord_onpoint.p_p,
			{  },
			"origin",
			{ "std_icon", application.a_coord_onpoint.p_p }
		    },
		    {   program.give_node_number,
			"prop_or_par_act_par",
			p_world,
			application.a_world_firstrota.p_an,
			{ "draft" },
			"angle",
			{ "std_icon", application.a_world_firstrota.p_an }
		    },
		    {   program.give_node_number,
			"prop_or_par_act_par",
			p_world,
			application.a_world_firstrota.p_s,
			{  },
			"scale",
			{ "std_icon", application.a_world_firstrota.p_s }
		    }
		  },
		  {  },
		  { program.give_node_number, application.o_user },
		  udo_name,
		  0,
		  { "", "" }
		})
	return(result_udo)
end

function make_softstyle(ele,nb)
    if (nb<1 or nb>16) then
       return
    end
    style = index(soft_styles,nb)
    if style.el_1 =  "none"  then
       return
    end
    draft_arrow(ele,style.el_1)
end

function make_container(group)
   var manips = {}
   for ele in group do
//      manips = manips
//       + (select .result from ele.manip_by where .type.name = "draft_arrow")
      manips = manips
       + (select . from ele.sons where .created_by.type.name = "draft_arrow")
   end
   draft_c = draft_container_absolute()

   udo_convert_to_layer(draft_c, false)
   group = group or manips
   layer_move_objects(group,draft_c)
   layer_convert_to_user(draft_c)
   return(draft_c)
end

function z_edit(plane,z)
   var elements = {}
   var act_name = eval("plane.created_by.type.name")
   if not valid(act_name) then
      return
   end

   if (act_name = "plane_ofelements") then
      elements = plane.par_poe
   end 
   if (act_name = "plane_onconstruction") then
      elements = select .first from plane.par_coc
   end 
   for ele in elements do
      prop_node = eval("application.o_"+ele.type.name+".p_z")
      if valid(prop_node) then
         edit(prop_node,ele,z)
      end
   end
end

function pre_handling()
   if not valid( application.a_draft_arrow) then
      uda_load("#/d2drw/udx/draft_arrow.uda")
   end
   if not valid( application.o_draft_container) then
      udo_load("#/d2drw/udx/draft_container.udo")
   end
   error_response("continue")
   file errorProtocol error_output
end

function post_handling()
   file <screen> error_output
   system("cat", errorProtocol)
end

function check_dim(repl,dim,dimValue,precision)
   if not keep_replace then
      if valid(dim) then
          if dim.dist = dimValue then
	     copy_user_atts(repl,dim)
	     name(dim,repl.name)
             delete(repl)
	     return(dim)
          else
             delete(dim)
             return(repl)
          end
      else
         `invalid dim` nl
      end
   end
   return(repl)
end

function check_cdi(repl,dim)
   if not keep_replace then
      if valid(dim) then
           delete((select .el_1 from repl))
	   return(dim)
      end
   end
   return(make_container((select .el_1 from repl)))
end


pre_handling()
